%
% This example illustrates the use of the gradient descent PPA on a simple parabola example
%
% Valero Laparra, 2012 (c)
% valero.laparra@uv.es
% http://isp.uv.es
%


clear all
close all

%% DATA: NOISY PARABOLA 

r = 3;
x = r*rand(1,1000)-r/2;
y = x.^2 + 0.05*randn(1,1000);
dat = [x/r; y];

figure
plot(dat(1,:),dat(2,:),'b.')
axis equal
title(['Original Data']) 

%% PPA 1D
for ord =1:2
    [datT Results] = PPA(dat,ord,2);

    %%
    idat = inv_PPA(datT,Results,1);
    
    figure
    plot(dat(1,:),dat(2,:),'b.')
    axis equal
    hold on
    plot(idat(1,:),idat(2,:),'r.')
    
    title(['PPA PCA BASIS, ord: ' num2str(ord)]) 
    
end

%% GRADIENT DESCENT
% It can take some minutes. Please, be patient.
fprintf('It can take some minutes. Please, be patient...')

max_it = 100;
inicialization = 1;
TAU = [-logspace(-6,2,10) 0 logspace(-6,2,10)];   
tol = 1;

for ord =1:2
    [datT Results] = PPA(dat,ord,2,TAU,inicialization,tol,max_it); 

    idat = inv_PPA(datT,Results,1);
    
    figure
    plot(dat(1,:),dat(2,:),'b.')
    axis equal
    hold on
    plot(idat(1,:),idat(2,:),'r.')
    
    title(['PPA Gradient Descent basis, ord: ' num2str(ord)])    
end


