
function [datT Results] = PPA_auto(dat_train,dat_test,Morden,DIM,TAU,inicialization,tol,max_it)

% PPA_auto(dat_train,dat_test,max_order,DIM,TAU,initialization,tol,max_it)

%% PARAMETERS
if ~exist('dat_test') || isempty(dat_test)
    ii = randperm(size(dat_train,2));
    aux = dat_train;
    dat_train = aux(:,ii(1:round(size(aux,2)/2)));
    dat_test = aux(:,ii(round(size(aux,2)/2)+1:end));
end

if ~exist('Morden')
    Morden = 10;
end

if ~exist('DIM'), DIM = 1; end

if ~exist('TAU')
    TAU = 0;
%    TAU = [fliplr(-logspace(-6,2,10)) 0 logspace(-6,2,10)];
end

if ~exist('inicialization'),  inicialization = 1; end

if ~exist('tol'), tol = 1; end

if ~exist('max_it'), max_it = 0; end


if DIM>size(dat_train,1)
    error('The dimensions of the input data have to be bigger than DIM')
end

%% ALGORITHM

aux_dat = dat_train';
aux_dat_test = dat_test';

for ind_d = 1:DIM 
    RR = [];
    ER = [];
    for orden = 1:Morden
          [RR(orden).Res RR(orden).err RR(orden).dat_trans] = PPA_1D(aux_dat,orden,TAU,inicialization,tol,max_it);
          [RR(orden).dat_trans_test] = apply_PPA_1D(aux_dat_test,RR(orden).Res);
          ER(orden) = sum(sum(RR(orden).dat_trans_test(:,2:end).^2));
          %[orden ind_d]
    end
    
    [mm ord] = min(ER);
        
    Results(ind_d).ord = ord;
    Results(ind_d).Res = RR(ord).Res;
    Results(ind_d).err = RR(ord).err;
    dat_trans = RR(ord).dat_trans;
    dat_trans_test = RR(ord).dat_trans_test;

    datT(:,ind_d) = dat_trans(:,1);
    aux_dat = dat_trans(:,2:end);
    aux_dat_test = dat_trans_test(:,2:end);
    
    % Results(ind_d).dat_trans = dat_trans;
end

datT = datT';

