

function [Res err dat_trans] = PPA_1D(X,orden,tau,inicialization,tol,max_it,file)



if size(X,2)>1 && orden>1
    Res.m = mean(X,1);
    X = X - repmat(Res.m,size(X,1),1);
    
    
    C = cov(X);
    [auxV auxD] = eig(C);
    dd = diag(auxD);
    [not_used, ii] = sort(dd,'descend');
    
    superV = auxV(:,ii);
    
    Q = zeros(orden+1);
    for in = 1:orden
        Q(in,in+1) = in;
    end
    
    for direc = 1%:size(superV,2)
        
        if (inicialization == 1) || ~exist('inicialization')
            V1 = superV(:,direc);
            V2 = superV(:,[1:direc-1 direc+1:end]);
        else
            V1 = superV(:,direc);
            V2 = superV(:,[1:direc-1 direc+1:end]);
        end
        
        GV = my_vander((X*V1)',orden)';
        W = pinv(GV)*X*V2;
        E = X*V2 - GV*W;
        
        err2 = [];
        kk=1;
        err2(kk) = sum(sum(E.^2));
        
        if exist('tol','var'),else tol=1;end
        if exist('max_it','var'),else max_it = 100000;end
        
        stop = 0;
        aux_tau = 0;
        while (err2(kk)>tol && kk<max_it && stop == 0)
            
            aux_3 = 2*E.*(GV*Q*W);
            for n = 1:size(X,2)
                dV1(n) = sum(sum(aux_3.*repmat(X(:,n),1,size(X,2)-1)));
            end
            
            aux_V1 = repmat(V1,1,length(tau)) + repmat(tau,size(V1,1),1).*repmat(dV1',1,length(tau));
            aux_V1 = aux_V1./repmat(sqrt(sum(aux_V1.^2)),size(aux_V1,1),1);
            
            for ind_t =1:length(tau)
                
                RESI(ind_t).aux_GV = my_vander((X*aux_V1(:,ind_t))',orden)';
                aux_E = (eye(size(RESI(ind_t).aux_GV,1)) - RESI(ind_t).aux_GV*pinv(RESI(ind_t).aux_GV))*X;
                
                er(ind_t) = sum(sum(aux_E.^2));
            end
            
            [not_used, ii] = min(er);
            
            V1 = aux_V1(:,ii);
            
            GV = RESI(ii).aux_GV;
            V = my_GramS([V1 V2]);
            W = pinv(GV)*X*V(:,2:end);
            
            E = X*V(:,2:end) - GV*W;
            kk = kk+1;
            err2(kk) = sum(sum(E.^2));
            
            aux_tau(kk) = tau(ii);
            if tau(ii) == 0
                tau = tau/10;
            end
            
            if kk>10
                if sum(err2(kk-10:kk-1) == repmat(err2(kk),1,10)) == 10
                    stop = 1;
                end
            end
        end
        aux_Res(direc).tau = aux_tau;
        aux_Res(direc).err = err2;
        ER(direc) = err2(end);
        aux_Res(direc).V1 = V1;
    end
    
    [not_used, ii] = min(ER);
    
    V1 = aux_Res(ii).V1;
    rrr = rank(V2);
    rand('seed',1);
    V = my_GramS([V1 V2(:,end-rrr+1:end) rand(size(V2,1),size(V2,2)-rrr)]);

    V2 = V(:,2:end);
    
    GV = my_vander((X*V1)',orden)';
    W = pinv(GV)*X*V2;
    
    estimaciones = GV*W;
    datm_T = X*V2;
    errores = datm_T - estimaciones;
    
    dat_trans = [X*V1 errores];
    Res.W = W;
    Res.V = V;
    Res.direc = ii;
    
    Res.tau = aux_Res(ii).tau;
    err = aux_Res(ii).err;
    for ii=1:length(aux_Res)
        Res.err(ii).er = aux_Res(ii).err;
    end
    
    if exist('file')
        save(file,'Res')
    end
    
elseif size(X,2)>1 && orden == 1
    
    Res.m = mean(X,1);
    X = X - repmat(Res.m,size(X,1),1);
    
    C = cov(X);
    [auxV auxD] = eig(C);
    dd = diag(auxD);
    [ss ii] = sort(dd,'descend');
    
    V = auxV(:,ii);
    V1 = V(:,1);
    
    W = zeros(1,size(V,1)-1);
    
    dat_trans = X*V;
    Res.W = W;
    Res.V = V;
    err = sum(sum((X*V(:,2:end)).^2));
    
else
    Res = 0;
    err = 0;
    dat_trans = X;
end

